//+------------------------------------------------------------------+
//|                                                      1ma-exp.mq4 |
//|                Copyright  2005, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#include <stdlib.mqh>

extern int myMagic = 20050715;

extern double TakeProfit = 100;
extern double StopLoss = 60;  
extern double TrailingStop = 35;  

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar, 

extern double Lots = 0.1;
extern double MaximumRisk = 10;
extern bool   FixedLot = false;

extern int       MA1Len=40;

extern int       StartTime=0; //hhmm
extern int       StopTime=2401; //hhmm

extern int       OrderTriesNumber=5;

extern string EAname="1ma";

bool buysig,sellsig,closebuy,closesell; int lastsig,tries,ttime;


double LotsRisk(int StopLoss)  { 
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/StopLoss,1);
   else
      lot=Lots;
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)  {
   int ord;
//----
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==symbol && OrderMagicNumber()==myMagic) ord++;
   }
//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
      double MA1=iMA(NULL,0,MA1Len,0,MODE_SMA,PRICE_CLOSE,shift);
      double MA2=iMA(NULL,0,MA1Len,0,MODE_SMA,PRICE_CLOSE,shift+1);


      buysig=false;
      sellsig=false;

      if ( Low[shift]>MA1 && Low[shift+1]<MA2 ) {
             buysig=true;
             sellsig=false;
      }
      if ( High[shift]<MA1 && High[shift+1]>MA2 ) {
             sellsig=true;
             buysig=false;
      }
      closebuy=sellsig;
      closesell=buysig;
}

void CheckForOpen() {
   int    res,tr;
//---- sell conditions
   if(sellsig && lastsig!=-1)  {
	   res=0;
	   tries=0;
		while (res<=0 && tries<OrderTriesNumber) {
          tr=0; while(tr<7 && !IsTradeAllowed()) { tr++; Sleep(5000); }
		    RefreshRates();
          res=OrderSend(Symbol(),OP_SELL,LotsRisk(StopLoss),Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,EAname,myMagic,0,Red);
		    if (res<0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		    tries++;
		}
      lastsig=-1;
      return;
   }
//---- buy conditions
   if(buysig && lastsig!=1)  {
	   res=0;
	   tries=0;
		while (res<=0 && tries<OrderTriesNumber) {
          tr=0; while(tr<7 && !IsTradeAllowed()) { tr++; Sleep(5000); }
		    RefreshRates();
          res=OrderSend(Symbol(),OP_BUY,LotsRisk(StopLoss),Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,EAname,myMagic,0,Blue);
          tries++;
		}
      lastsig = 1;
      return;
   }
}
  
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
      if(OrderMagicNumber()!=myMagic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if (closebuy) {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while(tr<7 && !IsTradeAllowed()) { tr++; Sleep(5000); }
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
		   }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if (closesell) {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while(tr<7 && !IsTradeAllowed()) { tr++; Sleep(5000); }
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
		   }
         break;
        }
     }
}


void TrailStop() {
   bool bres;
   double StopLoss;
   if ( TrailingStop > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+TrailingStop*Point )  return;
            StopLoss = Bid-TrailingStop*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-TrailingStop*Point )  return;
            StopLoss = Ask+TrailingStop*Point;
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

void start()  {

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   //---- check for signals
   CheckForSignals();

   //---- calculate open orders by current symbol
   int ctime=Hour()*100+Minute();
   int corders=CalculateCurrentOrders(Symbol());
   if (ctime>=StartTime && ctime<StopTime && corders==0) 
      CheckForOpen();
   if (corders>0)  {
      CheckForClose();
      TrailStop();
   }
}
//+------------------------------------------------------------------+